#ifndef POINT3D_H
#define POINT3D_H



#include <iostream>



class Point3D
{
	protected:
		float coords[3]; // Las tres coordenadas de un punto en 3D

	public:
		Point3D (void); // Constructor sin parmetros
		Point3D (float, float, float); // Constructor con parmetros
		Point3D (const Point3D&); // Constructor de copia
		Point3D & operator = (const Point3D &); // Operador de asignacin
		bool operator == (const Point3D &) const; // Operador de comparacin
		bool operator != (const Point3D &) const; // Operador distinto de
		bool Update (const float, const float, const float); // Actualiza las coordenadas del punto
		bool Update (const Point3D&); // Actualiza con los datos de otro punto
		void GetCoordinates (float&, float&, float&) const;
		void Actualiza (float, float, float);
		const float * const GetCoordinates (void) const;
		float Distance (const Point3D &) const; // Distancia entre dos puntos
		// A partir de aqui las funciones son relevantes solo para depuracin de cdigo
		friend std::ostream& operator << (std::ostream& os, Point3D&); // Para salida por consola

};

//#define Vertex Point3D


#endif