#ifndef ARBOL_H
#define ARBOL_H 


#include "Hoja.h"
#include "vertexdata.h"
#include "Point3D.h"
#include "Activas.h"



class Arbol
{
	private:
		Geometry::CREATEVERTEXDATAFUNC create_vertex_data_func;		
		Geometry::CREATEINDEXDATAFUNC create_index_data_func;

	public :
	// Variable members
		
		Geometry::VertexData *vertexdata;
		Geometry::IndexData *indexdata;

		Hoja   *Hojas;
		Activas  *MinDet; // primera hoja activa
		int nHojas;
		int TotHojas;
		
		float cx,cy,cz; //centro de la copa// para los impostores y resolucion variable
		float rad; //radio de la esfera envolvente
		int minHojas;

//		float *normales_vert;
//		float *normales_vert2;
//		float *tex_coords;
		int TotVerts;

	public :
		Arbol (const char *, const char *, const char*, Geometry::CREATEVERTEXDATAFUNC vdfun=NULL, Geometry::CREATEINDEXDATAFUNC idfun=NULL); // Constructor with the name of a file cotaining the data
		Arbol (Arbol *a);
		virtual ~Arbol (void); // Destructor
		
		// Montan la estructura
		void ReadFromFile (const char *, const char*, const char*/*, char**/); // Reads a obj-model from a file
		int LeeVertices ( const char * );
		int LeoHojas( const char *);
//		int LeoTronco( char *);
		int LeoHojasSimpl( const char*);
		void RellenoRaiz (void);

		void GetNormalH (Hoja&);
//		void GetNormalT(Tronco&);

		void CrossProduct(const float *v1, const float *v2, float *res);
		void Normalize(const float *v, float *res);
//		void CalculaNormalesVertice(void);
		void CalculaTexCoordsYNorms(void);
        
		
};

#endif